<?php
/**
* This file is part of the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/


/*
 * Attribut des Objects : AttachedFiles / Likes / Comments
 */
trait MdlObjectAttributes
{
	//Valeurs mises en cache
	private $_attachedFiles=null;
	private $_usersComment=null;
	private $_usersLike=null;

	/*
	 * FICHIER JOINT : Infos sur un fichier joint
	 */
	public static function getAttachedFile($tmpFile)
	{
		if(!empty($tmpFile))
		{
			//Si besoin, récup les infos en bdd
			if(is_numeric($tmpFile))  {$tmpFile=Db::getLine("SELECT * FROM ap_objectAttachedFile WHERE _id=".(int)$tmpFile);}//Si besoin, récup les infos en bdd
			//Ajoute le chemin && L'objet conteneur
			$tmpFile["path"]=PATH_OBJECT_ATTACHMENT.$tmpFile["_id"].".".File::extension($tmpFile["name"]);
			$tmpFile["containerObj"]=Ctrl::getObj($tmpFile["objectType"],$tmpFile["_idObject"]);
			return $tmpFile;
		}
	}

	/*
	 * FICHIER JOINT : Liste des fichiers joints de l'objet
	 */
	public function getAttachedFileList()
	{
		//Mise en cache des fichiers joints de l'objet & Ajoute le "path"
		if($this->_attachedFiles===null){
			$this->_attachedFiles=Db::getTab("SELECT * FROM ap_objectAttachedFile WHERE objectType='".static::objectType."' AND _idObject=".$this->_id);
			foreach($this->_attachedFiles as $fileKey=>$tmpFile)  {$this->_attachedFiles[$fileKey]=self::getAttachedFile($tmpFile);}
		}
		//Retoune les résultats
		return $this->_attachedFiles;
	}

	/*
	 * FICHIER JOINT : Menus des fichiers joints de l'objet (menu contextuel ou description) : affiche et propose le télécargement
	 */
	public function menuAttachedFiles($separator="<hr>")
	{
		if(count($this->getAttachedFileList())>0){
			$menuAttachedFiles=$separator;
			foreach($this->getAttachedFileList() as $tmpFile)
				{$menuAttachedFiles.="<div class='menuAttachedFile sLink' title=\"".Txt::trad("download")."\" onclick=\"if(confirm('".Txt::trad("download",true)." ?')) redir('?ctrl=object&action=downloadAttachedFile&_id=".$tmpFile["_id"]."');\"><img src='app/img/attachment.png'> ".$tmpFile["name"]."</div>";}
			return $menuAttachedFiles;
		}
	}

	/*
	 * FICHIER JOINT : Insert un fichier joint dans la description (image/video/audio/flash) : via une requete Sql OU l'editeur html
	 */
	public static function attachedFileInsert($_idFile, $editorInsert=true)
	{
		//Récupère l'image ou le player du média
		$insertText=null;
		$curFile=self::getAttachedFile($_idFile);
		$displayPath="?ctrl=object&action=DisplayAttachedFile&_id=".$curFile["_id"]."&name=".$curFile["name"];
		if(File::controlType("imageBrowser",$curFile["path"]))		{$insertText="<img src='".$displayPath."' style='max-width:100%;'>";}//garder le "style" pour tinyMce..
		elseif(File::controlType("mp3",$curFile["path"]))			{$insertText=File::getMediaPlayer($displayPath);}
		elseif(File::controlType("videoPlayer",$curFile["path"]))	{$insertText=File::getMediaPlayer($curFile["path"]);}//affichage direct
		//Retourne le résultat
		if(!empty($insertText)){
			$insertText="<div id='tagAttachedFile".$curFile["_id"]."' title='".str_replace("'",null,$curFile["name"])."'>".$insertText."</div>";
			return ($editorInsert==true)  ?  "onclick=\"tinymce.activeEditor.setContent(tinymce.activeEditor.getContent()+'".addslashes(str_replace("\"","'",$insertText))."');\""  :  $insertText;
		}
	}

	/*
	 * FICHIER JOINT : Ajoute les fichiers joints du "menuEdit()"
	 */
	public function addAttachedFiles()
	{
		if(static::hasAttachedFiles==true)
		{
			$curDatasFolderSize=File::datasFolderSize();
			foreach($_FILES as $inputId=>$curFile)
			{
				if(stristr($inputId,"addAttachedFile"))
				{
					////	Pas assez d'espace disque?  /  Fichier bien telechargé?
					if(($curDatasFolderSize+$curFile["size"]) > limite_espace_disque)	{Ctrl::addNotif("NOTIF_diskSpace");  break;}//sort de la boucle..
					elseif($curFile["error"]==0)
					{
						//Ajoute le fichier en Bdd et dans le dossier de destination
						$attachedFileId=Db::query("INSERT INTO ap_objectAttachedFile SET name=".Db::format($curFile["name"]).", objectType='".static::objectType."', _idObject=".$this->_id, true);
						$fileDestPath=PATH_OBJECT_ATTACHMENT.$attachedFileId.".".File::extension($curFile["name"]);
						$isMoved=move_uploaded_file($curFile["tmp_name"], $fileDestPath);
						if($isMoved!=false)
						{
							//Optimise le fichier
							if(File::controlType("imageResize",$fileDestPath))	{File::imageResize($fileDestPath,$fileDestPath,1200);}
							File::setChmod($fileDestPath);
							//Ajoute l'image/vidéo/Mp3 dans la description
							$insertCheckboxId=str_replace("addAttachedFile","addAttachedFileInsert",$inputId);
							if(static::htmlEditorField!=null && Req::isParam($insertCheckboxId) && File::controlType("attachedFileInsert",$curFile["name"])){
								$newEditorValue=Db::getVal("SELECT ".static::htmlEditorField." FROM ".static::dbTable." WHERE _id=".$this->_id).self::attachedFileInsert($attachedFileId,false);
								Db::query("UPDATE ".static::dbTable." SET ".static::htmlEditorField."=".Db::format($newEditorValue,"editor")." WHERE _id=".$this->_id);
							}
							$curDatasFolderSize+=$curFile["size"];
						}
					}
				}
			}
			File::datasFolderSize(true);//Recalcule $_SESSION["datasFolderSize"]
		}
	}

	/*
	 * FICHIER JOINT : Supprime un fichier joint
	 */
	public function deleteAttachedFile($curFile)
	{
		if($this->editRight() && is_array($curFile)){
			File::rm($curFile["path"]);
			if(!is_file($curFile["path"])){
				Db::query("DELETE FROM ap_objectAttachedFile WHERE _id=".(int)$curFile["_id"]);
				return true;
			}
		}
	}

	/*
	 * COMMENTAIRES : l'objet peut avoir des commentaires?
	 */
	public function hasUsersComment()
	{
		return (static::hasUsersComment && !empty(Ctrl::$agora->usersComment));
	}

	/*
	 * COMMENTAIRES : Liste les commentaires
	 */
	public function getUsersComment()
	{
		//Mise en cache des commentaires de l'objet
		if($this->_usersComment===null)
			{$this->_usersComment=Db::getTab("SELECT * FROM ap_objectComment WHERE objectType='".static::objectType."' AND _idObject=".$this->_id);}
		//Renvoi les résultats
		return $this->_usersComment;
	}

	/*
	 * COMMENTAIRE : droit d'édition/suppression d'un commentaire
	 */
	public static function userCommentEditRight($_idComment)
	{
		if(!empty($_idComment)){
			$idUser=Db::getVal("SELECT _idUser FROM ap_objectComment WHERE _id=".(int)$_idComment);
			return (Ctrl::$curUser->isAdminGeneral() || $idUser==Ctrl::$curUser->_id);
		}
	}

	/*
	 * LIKES : l'objet peut avoir des "likes"?
	 */
	public function hasUsersLike()
	{
		return (static::hasUsersLike && !empty(Ctrl::$agora->usersLike));
	}

	/*
	 * LIKES : Liste des "like"/"dontlike" (passer en parametre)
	 */
	public function getUsersLike($like_dontlike)
	{
		//Mise en cache des likes de l'objet
		if($this->_usersLike===null){
			$this->_usersLike=["like"=>[],"dontlike"=>[]];
			foreach(Db::getTab("SELECT * FROM ap_objectLike WHERE objectType='".static::objectType."' AND _idObject=".$this->_id)  as  $tmpLike){
				if(!empty($tmpLike["value"]))	{$this->_usersLike["like"][]=$tmpLike;}
				else							{$this->_usersLike["dontlike"][]=$tmpLike;}
			}
		}
		//Renvoie le résultat
		return $this->_usersLike[$like_dontlike];
	}
}