<?php
/**
* This file is part of the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/


/*
 * Menus des Objects
 */
trait MdlObjectMenus
{
	/*
	 * Balise ouvrante du block de l'objet : contient l'Url d'édition (pour le DblClick)  et l'id du menu contextuel (Click droit)
	 */
	public function divContainer($addClass=null, $addAttribute=null)
	{
		$urlEdit=($this->editRight())  ?  "data-urlEdit=\"".$this->getUrl("edit")."\""  :  null;
		return  "<div class=\"objContainer sBlock ".$addClass."\" ".$addAttribute." id=\"".$this->contextMenuId("block",true)."\" for=\"".$this->contextMenuId("menu")."\" ".$urlEdit.">";
	}

	/*
	 * Identifiant du menu contextuel : pour le "block" ou pour le "menu"
	 */
	public function contextMenuId($for, $reloadUniqid=false)
	{
		if(static::$contextMenuUniqId===null || $reloadUniqid==true)  {static::$contextMenuUniqId=uniqid();}//Id du menu
		$prefix=($for=="block")  ?  "objBlock_"  :  "objContextMenu_";//Préfixe de l'identifiant
		return $prefix.$this->_targetObjId."_".static::$contextMenuUniqId;
	}

	/*
	 * VUE : Menu contextuel (édition, droit d'accès, etc)
	 * $options => "deleteLabel" / "specificOptions"
	 */
	public function contextMenu($options=null)
	{
		////	INIT  &  DIVERSES OPTIONS (exple: "array('actionJs'=>'?ctrl=file&action=monAction','iconSrc'=>'app/img/plus.png','label'=>'mon option spécifique','tooltip'=>'mon tooltip')")
		$vDatas["curObj"]=$this;
		$vDatas["inlineLauncher"]=(!empty($options["inlineLauncher"])) ? true : false;
		$vDatas["specificOptions"]=(!empty($options["specificOptions"])) ? $options["specificOptions"] : array();
		////	OBJET USER
		if(static::objectType=="user")
		{
			////	MODIFIER ELEMENT  &  MODIF MESSENGER
			if($this->editRight()){
				$vDatas["editLabel"]=Txt::trad("USER_profilEdit");
				$vDatas["editMessengerObjUrl"]="?ctrl=user&action=UserEditMessenger&targetObjId=".$this->_targetObjId;
			}
			////	SUPPRESSION DE L'ESPACE COURANT
			if($this->deleteFromCurSpaceRight()){
				$deleteFromSpaceUrl="?ctrl=user&action=deleteFromCurSpace&targetObjects[".static::objectType."]=".$this->_id;
				$vDatas["confirmDeleteFromSpace"]="confirmDelete('".$deleteFromSpaceUrl."', '".Txt::trad("USER_confirmDeleteFromSpace",true)."')";
			}
			////	SUPPRESSION DEFINITIVE
			if($this->deleteRight()){
				$vDatas["confirmDeleteJs"]="confirmDelete('".$this->getUrl("delete")."', '".Txt::trad("confirmDeleteDbl",true)."')";
				$vDatas["deleteLabel"]=Txt::trad("USER_deleteDefinitely");
			}
			////	ESPACE DE L'UTILISATEUR
			if(Ctrl::$curUser->isAdminGeneral()){
				$vDatas["userSpaceList"]=Txt::trad("USER_spaceList")." : ";
				if(count($this->getSpaces())==0)	{$vDatas["userSpaceList"].=Txt::trad("USER_spaceNoAffectation");}
				else								{ foreach($this->getSpaces() as $tmpSpace)  {$vDatas["userSpaceList"].="<br>".$tmpSpace->name;} }
			}
		}
		////	OBJET LAMBDA
		else
		{
			////	MODIFIER ELEMENT  &  CHANGER DE DOSSIER  &  LOGS/HISTORIQUE
			if($this->editRight()){
				$vDatas["editLabel"]=(static::hasAccessRight==true && $this->isIndependant())  ?  Txt::trad("modifyAndAccesRight")  :  Txt::trad("modify");
				if($this::isInArbo())	{$vDatas["moveObjectUrl"]="?ctrl=object&action=FolderMove&targetObjId=".$this->containerObj()->_targetObjId."&targetObjects[".static::objectType."]=".$this->_id;}
				$vDatas["logUrl"]="?ctrl=object&action=logs&targetObjId=".$this->_targetObjId;
			}
			////	SUPPRIMER
			if($this->deleteRight())
			{
				$confirmDeleteParams=null;
				if(static::objectType=="space"){
					$confirmDeleteParams=", '".Txt::trad("SPACE_confirmDeleteDbl",true)."'";//Double confirmation
				}elseif(static::isContainer()){
					$confirmDeleteParams=", '".Txt::trad("confirmDeleteDbl",true)."'";//Double confirmation
					if(static::isFolder==true)  {$confirmDeleteParams.=", '?ctrl=object&action=SubFoldersDeleteControl&targetObjId=".$this->_targetObjId."', '".Txt::trad("confirmDeleteFolder",true)."'";}//Controle AJAX des droits d'accès
				}
				$vDatas["confirmDeleteJs"]="confirmDelete('".$this->getUrl("delete")."' ".$confirmDeleteParams.")";
				$vDatas["deleteLabel"]=(!empty($options["deleteLabel"]))  ?  $options["deleteLabel"]  :  Txt::trad("delete");
			}
			////	INFOS DES DROITS D'ACCESS (AUX ESPACES, USERS, ETC)
			if(static::hasAccessRight==true)
			{
				if(Ctrl::$curUser->isUser() && $this->isIndependant())
				{
					//Init
					$vDatas["isPersoAccess"]=true;
					$vDatas["affectLabels"]=$vDatas["affectTooltips"]=["1"=>null,"1.5"=>null,"2"=>null];
					//Libellé des affectations (& Icone d'element Perso?)
					foreach($this->getAffectations() as $tmpAffect){
						if($tmpAffect["targetType"]!="user" || Ctrl::$curUser->_id!=$tmpAffect["targetId"])  {$vDatas["isPersoAccess"]=false;}
						$vDatas["affectLabels"][$tmpAffect["accessRight"]].=$tmpAffect["label"]."<br>";
					}
					foreach($vDatas["affectLabels"] as $affectRight=>$affectLabel)	{$vDatas["affectLabels"][$affectRight]=trim($affectLabel,", ");}//Enlève dernières virgules pour les affectation d'users
					//Tooltip des droits d'accès
					$affectAutor=(static::isContainer())  ?  "<hr>".$this->tradObject("autorPrivilege")  :  null;//"Seul l'auteur peut modifier les droits d'accès.."
					if(!empty($vDatas["affectLabels"]["1"]))	{$vDatas["affectTooltips"]["1"]=Txt::trad("readInfos");}
					if(!empty($vDatas["affectLabels"]["1.5"]))	{$vDatas["affectTooltips"]["1.5"]=$this->tradObject("readLimitInfos").$affectAutor;}
					if(!empty($vDatas["affectLabels"]["2"]))	{$vDatas["affectTooltips"]["2"]=(static::isContainer())  ?  $this->tradObject("writeInfosContainer").$affectAutor  :  Txt::trad("writeInfos");}//si c'est un conteneur : "possibilité de modifier tous les elements du dossier"
				}
			}
			////	AUTEUR ET DATE
			//Auteur/invité + date création (optionnelle)
			$vDatas["infosCrea"]["autor"]=$this->displayAutor();
			$vDatas["infosCrea"]["date"]=(!empty($this->dateCrea)) ? "<br>".$this->displayDate(true,"full") : null;
			//Auteur + date Modif
			if(!empty($this->_idUserModif)){
				$vDatas["infosModif"]["autor"]=$this->displayAutor(false);
				$vDatas["infosModif"]["date"]="<br>".$this->displayDate(false,"full");
			}
			//Nouvel objet (créé depuis la dernière connexion)
			$dateCreaTime=strtotime($this->dateCrea);
			$vDatas["newObjectSinceConnection"]=(Ctrl::$curUser->isUser() && ($dateCreaTime>Ctrl::$curUser->previousConnection || $dateCreaTime>(time()-86400)))  ?  true  :  false;
		}
		////	Affichage
		return Ctrl::getVue(Req::commonPath."Vue/VueObjMenuContext.php",$vDatas);
	}

	/*
	 * VUE : Menu d'édition (droits d'accès, fichiers joints, etc)
	 */
	public function menuEdit()
	{
		////	MENU D'IDENTIFICATION D'UN INVITÉ
		if(Ctrl::$curUser->isUser()==false){
			$vDatas["mainMenu"]="identification";
			$vDatas["mainMenuLabel"]=Txt::trad("EDIT_identification");
		}
		////	OPTIONS RESERVES AUX USERS
		else
		{
			////	Menu des droits d'accès
			if(static::hasAccessRight==true && $this->isIndependant())
			{
				////	Init & Label
				$vDatas["mainMenu"]="accessRights";
				$vDatas["mainMenuLabel"]=(static::isContainer())  ?  Txt::trad("EDIT_accessRightContent")." <img src='app/img/info.png' title=\"".$this->tradObject("autorPrivilege")."\">"  :  Txt::trad("EDIT_accessRight");
				////	Droits d'accès pour chaque espace ("targets")
				$vDatas["blocksAccessRight"]=[];
				foreach(Ctrl::$curUser->getSpaces() as $tmpSpace)
				{
					//Verif si le module de l'objet est bien activé sur l'espace
					if(array_key_exists(static::moduleName,$tmpSpace->moduleList()))
					{
						//Init
						$tmpSpace->targetLines=[];
						////	Tous les utilisateurs de l'espace
						$tmpSpace->targetLines[]=["targetId"=>$tmpSpace->_id."_spaceUsers", "label"=>Txt::trad("EDIT_allUsers"), "icon"=>"user/icon.png", "tooltip"=>Txt::trad("EDIT_allUsersInfo")];
						////	Invités
						if($tmpSpace->public=="1")
							{$tmpSpace->targetLines[]=["targetId"=>$tmpSpace->_id."_spaceGuests", "label"=>Txt::trad("EDIT_spaceGuests"), "icon"=>"public.png", "onlyReadAccess"=>true];}
						////	Groupe d'utilisateurs de l'espace
						foreach(MdlUserGroup::getGroups($tmpSpace) as $tmpGroup)
							{$tmpSpace->targetLines[]=["targetId"=>$tmpSpace->_id."_G".$tmpGroup->_id, "label"=>$tmpGroup->title, "icon"=>"user/userGroup.png", "tooltip"=>Txt::reduce($tmpGroup->usersLabel)];}
						////	Chaque user de l'espace
						foreach($tmpSpace->getUsers() as $tmpUser){
							$curUserTooltip=($tmpSpace->userAccessRight($tmpUser)==2)  ?  Txt::trad("EDIT_adminSpace")  :  null;
							$curUserFullAccess=($tmpSpace->userAccessRight($tmpUser)==2 || $tmpUser->_id==Ctrl::$curUser->_id)  ?  true  :  false;
							$hideUser=($tmpUser->_id!=Ctrl::$curUser->_id)  ?  true  :  false;
							$tmpSpace->targetLines[]=["targetId"=>$tmpSpace->_id."_U".$tmpUser->_id, "label"=>$tmpUser->display(), "icon"=>"user.png", "tooltip"=>$curUserTooltip, "onlyFullAccess"=>$curUserFullAccess, "isUser"=>true, "hideUser"=>$hideUser];
						}
						////	Ajoute l'espace
						$vDatas["blocksAccessRight"][]=$tmpSpace;
					}
				}
				////	Prépare les targets de chaque espace
				$objAffects=$this->getAffectations();
				foreach($vDatas["blocksAccessRight"] as $tmpSpaceKey=>$tmpSpace)
				{
					foreach($tmpSpace->targetLines as $targetKey=>$targetLine)
					{
						//Init les propriétés des checkboxes (pas de "class"!). Utilise des "id" pour une sélection rapide des checkboxes par jQuery
						$targetId=$targetLine["targetId"];
						foreach(["1","1.5","2"] as $tmpRight)  {$targetLine["boxProp"][$tmpRight]="value=\"".$targetId."_".$tmpRight."\"  id=\"objectRightBox_".$targetId."_".str_replace('.','',$tmpRight)."\"";}//""str_replace": on utilise "_15" au lieu de "_1.5" à cause du selector jQuery
						//Boxes : Checked ou Disabled
						if(array_key_exists($targetId,$objAffects))	{$targetLine["boxProp"][$objAffects[$targetId]["accessRight"]].=" checked";}
						if(!empty($targetLine["onlyFullAccess"]))	{$targetLine["boxProp"]["1"].=" disabled";  $targetLine["boxProp"]["1.5"].=" disabled";}
						if(!empty($targetLine["onlyReadAccess"]))	{$targetLine["boxProp"]["2"].=" disabled";}
						//Affiche les menu "Plus d'utilisateurs ?"
						if(!empty($targetLine["hideUser"]))  {$vDatas["blocksAccessRight"][$tmpSpaceKey]->showAllSpaceUsers=true;}
						//Met à jour les propriétés de la target
						$vDatas["blocksAccessRight"][$tmpSpaceKey]->targetLines[$targetKey]=$targetLine;
					}
				}
			}
			////	OPTION "FICHIERS JOINTS"
			if(static::hasAttachedFiles==true){
				$vDatas["attachedFiles"]=true;
				$vDatas["attachedFilesList"]=$this->getAttachedFileList();
			}
			////	OPTIONS NOTIFICATION PAR MAIL
			if(static::hasNotifMail==true && function_exists("mail")){
				$vDatas["moreOptions"]=$vDatas["notifMail"]=true;
				$vDatas["notifMailUsers"]=Ctrl::$curUser->usersVisibles(true);
				$vDatas["curSpaceUsersIds"]=Ctrl::$curSpace->getUsers("ids");
			}
			////	OPTION "SHORTCUT"
			if(static::hasShortcut==true){
				$vDatas["moreOptions"]=$vDatas["shortcut"]=true;
				$vDatas["shortcutChecked"]=(!empty($this->shortcut)) ? "checked" : null;
			}
		}
		////	AFFICHE LA VUE
		$vDatas["curObj"]=$this;
		$vDatas["writeReadLimitInfos"]=$this->tradObject("readLimitInfos");
		$vDatas["extendToSubfolders"]=(static::isFolder==true && $this->isNew()==false && Db::getVal("SELECT count(*) FROM ".static::dbTable." WHERE _idContainer=".$this->_id)>0)  ?  true  :  false;//dossier avec des sous-dossiers
		return Ctrl::getVue(Req::commonPath."Vue/VueObjMenuEdit.php",$vDatas);
	}

	/*
	 * STATIC : Clé de préférence en Bdd ($prefDbKey) : objet passé en parametre / conteneur ou dossier courant / module courant
	 */
	public static function getPrefDbKey($containerObj)
	{
		if(is_object($containerObj))		{return $containerObj->_targetObjId;}
		elseif(!empty(Ctrl::$curContainer))	{return Ctrl::$curContainer->_targetObjId;}
		else								{return static::moduleName;}
	}

	/*
	 * VUE : Menu de sélection d'objets (menu contextuel flottant)
	 */
	public static function menuSelectObjects($containerObj=null)
	{
		$vDatas["containerObj"]=($containerObj==null && !empty(Ctrl::$curContainer)) ? Ctrl::$curContainer : $containerObj;//Conteneur/Dossier courant en référence?
		return Ctrl::getVue(Req::commonPath."Vue/VueObjMenuSelection.php",$vDatas);
	}

	/*
	 * STATIC : Tri d'objets : Preference en Bdd / paramètre passé en Get
	 * exple: "firstName@@asc"
	 */
	private static function getSort($containerObj=null)
	{
		//Récupère la préférence en Bdd ou params GET/POST
		$objectsSort=Ctrl::prefUser("sort_".static::getPrefDbKey($containerObj), "sort");
		//Tri par défaut si aucune préférence n'est précisé ou le tri sélectionné n'est pas dispo pour l'objet courant 
		if(empty($objectsSort) || !in_array($objectsSort,static::$sortFields))    {$objectsSort=static::$sortFields[0];}
		//renvoie le tri
		return $objectsSort;
	}

	/*
	 * STATIC SQL : Tri Sql des objets (avec premier tri si besoin : news, subject, etc)
	 * exple: "ORDER BY firstName asc"
	 */
	public static function sqlSort($containerObj=null, $firstSort=null)
	{
		//Récupère la préférence de tri d'un objet (dossier ou autre)
		$curSortTab=Txt::txt2tab(self::getSort($containerObj));
		//Tri par extension (de fichier ou autre) ?
		$mainSort=($curSortTab[0]=="extension") ? "SUBSTRING_INDEX(name,'.',-1)" : $curSortTab[0];
		//Renvoie le tri Sql
		return "ORDER BY ".$firstSort." ".$mainSort." ".$curSortTab[1];
	}

	/*
	 * VUE : Menu de tri d'un type d'objet
	 */
	public static function menuSort($containerObj=null)
	{
		$vDatas["curSort"]=self::getSort($containerObj);
		$vDatas["curSortTab"]=Txt::txt2tab($vDatas["curSort"]);
		foreach(static::$sortFields as $tmpSort){
			$curSortTab=Txt::txt2tab($tmpSort);
			$vDatas["sortFields"][]=array("url"=>Tool::getParamsUrl("sort")."&sort=".$tmpSort, "sort"=>$tmpSort, "field"=>$curSortTab[0], "ascDesc"=>$curSortTab[1]);
		}
		return Ctrl::getVue(Req::commonPath."Vue/VueObjMenuSort.php",$vDatas);
	}

	/*
	 * STATIC : Récupère le type d'affichage de la page
	 */
	public static function getDisplayMode($containerObj=null)
	{
		if(static::$_displayMode===null){
			static::$_displayMode=Ctrl::prefUser("displayMode_".static::getPrefDbKey($containerObj), "displayMode");
			if(empty(static::$_displayMode))  {static::$_displayMode=static::$displayModeOptions[0];}//Affichage par défaut
		}
		return static::$_displayMode;
	}

	/*
	 * VUE : Menu d'affichage des objets dans une page : Blocks / Lignes (cf. $displayModeOptions)
	 */
	public static function menuDisplayMode($containerObj=null)
	{
		$vDatas["displayModeOptions"]=static::$displayModeOptions;
		$vDatas["displayMode"]=static::getDisplayMode($containerObj);
		$vDatas["displayModeUrl"]=Tool::getParamsUrl("displayMode")."&displayMode=";
		return Ctrl::getVue(Req::commonPath."Vue/VueObjMenuDisplayMode.php",$vDatas);
	}

	/*
	 * STATIC SQL : Filtrage de pagination
	 */
	public static function sqlPagination()
	{
		$offset=(Req::isParam("pageNb"))  ?  ((Req::getParam("pageNb")-1)*static::nbObjectsByPage)  :  "0";
		return "LIMIT ".static::nbObjectsByPage." OFFSET ".$offset;
	}

	/*
	 * VUE : Menu de filtre alphabétique (passe en parametre la requete sql pour récupérer les
	 */
	public static function menuPagination($displayedObjNb, $getParamKey=null)
	{
		$pageNbTotal=ceil($displayedObjNb/static::nbObjectsByPage);
		if($pageNbTotal>1)
		{
			//Nb de page et numéro de page courant
			$vDatas["pageNbTotal"]=$pageNbTotal;
			$vDatas["pageNb"]=$pageNb=Req::isParam("pageNb") ? Req::getParam("pageNb") : 1;
			//Url de redirection de base
			$vDatas["hrefBase"]="?ctrl=".Req::$curCtrl;
			if(!empty($getParamKey) && Req::isParam($getParamKey))  {$vDatas["hrefBase"].="&".$getParamKey."=".Req::getParam($getParamKey);}
			$vDatas["hrefBase"].="&pageNb=";
			//Page Précédente / Suivante
			$vDatas["prevAttr"]=($pageNb>1)  ?  "href=\"".$vDatas["hrefBase"].((int)$pageNb-1)."\""  :  "class='vNavMenuDisabled'";
			$vDatas["nextAttr"]=($pageNb<$pageNbTotal)  ?  "href=\"".$vDatas["hrefBase"].((int)$pageNb+1)."\""  :  "class='vNavMenuDisabled'";
			//Récupère le menu
			return Ctrl::getVue(Req::commonPath."Vue/VueObjMenuPagination.php",$vDatas);
		}
	}

	/*
	 * Menu spécifique d'affectation aux espaces : Thèmes de forum / Categories d'evenement
	 */
	public function menuSpaceAffectation()
	{
		$vDatas["curObj"]=$this;
		////	Liste des espaces
		$vDatas["spaceList"]=Ctrl::$curUser->getSpaces();
		//Pour chaque espace : check espace affecté (déjà affecté à l'objet OU nouvel objet + espace courant)
		foreach($vDatas["spaceList"] as $tmpSpace){
			$tmpSpace->checked=(in_array($tmpSpace->_id,$this->spaceIds) || ($this->isNew() && $tmpSpace->_id==Ctrl::$curSpace->_id))  ?  "checked"  :  null;
		}
		////	pseudo Espace "Tous les espaces"
		if(Ctrl::$curUser->isAdminGeneral()){
			$spaceAllSpaces=new MdlSpace();
			$spaceAllSpaces->_id="all";
			$spaceAllSpaces->name=Txt::trad("visibleAllSpaces");
			$spaceAllSpaces->checked=(Ctrl::$curUser->isAdminGeneral() && $this->isNew()==false && empty($this->spaceIds))  ?  "checked"  :  null;//Check "tous les utilisateurs"?
			array_unshift($vDatas["spaceList"],$spaceAllSpaces);
		}
		//Affiche le menu
		$vDatas["displayMenu"]=(Ctrl::$curUser->isAdminGeneral() && count($vDatas["spaceList"])>1) ? true : false;
		return Ctrl::getVue(Req::commonPath."Vue/VueObjMenuSpaceAffectation.php",$vDatas);
	}
}