/**
*------------------------V3---------------------------
* This file is part of the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/


/*
 * PAGE INIT  =>  PAGE LOAD / PAGE RESIZE / REQUETE AJAX
 */
$(function(){
	pageLoadTimestamp=Date.now();
	extendJquery();
	initTooltips();
	checkboxLabel();
	contextMenu();
	mainPageDisplay();													//menu flottant / largeur des blocks d'objet / clic sur les blocks d'objet / Gallerie d'image via LightBox  /  Etc.
	inputControls();													//Controles de champs (Datepickers, FileSize..)
	$(document).toastmessage({position:"top-center",stayTime:8000});	//Notifications 8sec.
	$("input[type='password']").attr("autocomplete","off");				//Pass
	$(".confirmEventLib").effect("pulsate",{times:50},50000);			//"pulsate" sur les confirm. d'evt
});

/*
 * RESIZE : redéfini les elements de la page, avec "debounceDelay" pour lancer l'action en fin de resize
 */
if(isMobile()==false){
	$(window).resize(
		debounceDelay(function(){ mainPageDisplay(); },50)
	);
}

/*
 * PAGE INIT : Fonctions étendues à Jquery
 */
function extendJquery()
{
	////	Vitesse (duration) par défaut des effets : "fadeIn()", "toggle()", etc
	$.fx.speeds._default=100;

	////	Verifie l'existance d'un element
	$.fn.exist=function(){
		return (this.length>0) ? true : false;
	};
	////	Verifie si l'element n'a pas de valeur ("empty") ...et aussi s'il existe
	$.fn.isEmpty=function(){
		return (this.length==0 || this.val().length==0) ? true : false;
	};
	////	Focus sur un champs surligné en rouge
	$.fn.focusRed=function(){
		this.addClass("focusRed").focus();
	};
	////	Affichage/masquage d'element : "surcharge" de fonctions de base de Jquery
	if(inIframe())
	{
		var fadeInBASIC=$.fn.fadeIn;
		var showBASIC=$.fn.show;
		var toggleBASIC=$.fn.toggle;
		var slideToggleBASIC=$.fn.slideToggle;
		var fadeToggleBASIC=$.fn.fadeToggle;
		$.fn.fadeIn=function(){			lightboxResize();	return fadeInBASIC.apply(this,arguments); };
		$.fn.show=function(){			lightboxResize();	return showBASIC.apply(this,arguments); };
		$.fn.toggle=function(){			lightboxResize();	return toggleBASIC.apply(this,arguments); };
		$.fn.slideToggle=function(){	lightboxResize();	return slideToggleBASIC.apply(this,arguments); };
		$.fn.fadeToggle=function(){		lightboxResize();	return fadeToggleBASIC.apply(this,arguments); };
	}
}

/*
 * PAGE INIT : Init les tooltips avec Tooltipster (cf. attribut "title")
 */
function initTooltips()
{
	//utile pour une réinit d'un tooltip (delay de 700ms pour pas avoir d'affichage intenpestif)
	tooltipsterOptions={contentAsHTML:true, multiple:true, animation:"grow", delay:700, speed:100, position:"bottom", theme:"tooltipster-shadow"};
	//Lance le tooltip, sauf en responsive
	if(isMobile()==false)  {$("[title]").not(".noTooltip,[title='']").tooltipster(tooltipsterOptions);}
}

/*
 * PAGE INIT : Click un label lié à une checkbox OU une checkbox lié à un label : change le style!
 *			La balise "<label>" doit avoir une propriété "for" correspondant à un "id" de checkbox
 *			Ignorer les "objectRight[]" & "targetObjects[]" qui ont leur propre fonctionnement (checkbox pour sélections et affectations)
 */
function checkboxLabel()
{
	//Lance une première fois la fonction (init)
	checkboxLabelStyle();
	//Lance ensuite à chaque changement de label/checkbox/radio
	$("label[for], :checkbox[id]:not([name^='objectRight'],[name^='targetObjects']), :radio[id]").change(debounceDelay(function(){  checkboxLabelStyle();  },100));
}
function checkboxLabelStyle()
{
	$(":checkbox[id]:not([name^='objectRight'],[name^='targetObjects']), :radio[id]").each(function(){
		if(this.checked)		{$("label[for='"+this.id+"']").removeClass("sLink").addClass("sLinkSelect");}
		else if(!this.disabled)	{$("label[for='"+this.id+"']").removeClass("sLinkSelect").addClass("sLink");}
		else					{$("label[for='"+this.id+"']").css("cursor","default");}//pas de "cursor:pointer"
	});
}

/*
 * Debounce : execute le code passé en paramètre (callback) après un certain délai, mais repousse l'execution du callback si "debounceDelay()" est relancée avant la fin du délai
 * Evite ainsi de saturer le browser, par exemple avec fonction qui fait boucler une sélection d'objets ou de labels
 */
function debounceDelay(callback, delay)
{
	//init le timer et lance la fonction avec le callback
	var debounceTimer;
	return function()
	{
		//Arguments et "this" rajoutés dans le "callback"
		var args=arguments;
		var context=this;
		clearTimeout(debounceTimer);
		//Lance le callback avec le delais demandé
		debounceTimer=setTimeout(function(){
			callback.apply(context, args);
		}, delay);
	}
}

/*
 * PAGE INIT : Init les menus contextuels
 * chaque launcher (icone/texte/block d'objet) doit avoir la propriété "for" correspondant à l'ID du menu  &&  une class "menuLaunch" (sauf les launcher de block d'objet) 
 */
function contextMenu()
{
	////	Mode responsive
	if(isMobile())
	{
		////	Click d'un launcher de menu (icone/texte)
		$(".menuLaunch").click(function(){
			//On est déjà dans le menu responsive : affiche en tant que sous-menu  /  Sinon on affiche le menu responsive
			if($("#respMenuContent").is(":visible"))	{$("#"+this.getAttribute("for")).addClass("contextMenuSubMenu").slideToggle();}
			else
			{
				//Id du menu à afficher. Le menu responsive peut être la fusion de 2 menus, exemple : menu des modules & menu contextuel du module courant
				curRespMenuOneId="#"+this.getAttribute("for");
				curRespMenuTwoId=(this.getAttribute("forTwo"))  ?  "#"+this.getAttribute("forTwo")  :  null;
				//Déplace le contenu du menu dans "#respMenuContentOne/Two" (conserve les listeners par rapport à un clonage via "html()")
				$(curRespMenuOneId+">*").appendTo("#respMenuContentOne");
				if(curRespMenuTwoId!=null)  {$(curRespMenuTwoId+">*").appendTo("#respMenuContentTwo");}
				//Affiche le menu avec un décalage de 200ms, le temps de récupérer le contenu du menu
				setTimeout(function(){
					$("#respMenuMain,#respMenuBg").show();
					$("body").css("overflow","hidden");//pas de scroll de page en arriere plan
				},200);
			}
		});
		////	Masque le menu
		function closeRespMenu(){
			$("#respMenuMain,#respMenuBg").fadeOut(50);
			$("#respMenuContentOne>*").appendTo(curRespMenuOneId);//Remet le menu dans le div d'origine
			if(curRespMenuTwoId!=null)  {$("#respMenuContentTwo>*").appendTo(curRespMenuTwoId);}//idem
			$("body").css("overflow","visible");//remet le scroll sur le body (..normal)
		}
		//Lance le masquage au click/swipe du menu
		$("#respMenuClose,#respMenuBg").on("click",function(){ closeRespMenu(); });
		$.getScript("app/js/jquery.touchSwipe.min.js");
		if($.isFunction($.fn.swipe)){
			$("#respMenuMain,#respMenuBg").swipe({
				swipe:function(event,direction){ if(direction=="right"){closeRespMenu();} },threshold:30,allowPageScroll:"vertical"//"30"=>longueur du swipe en pixels & "vertical=>autorise le scroll vertical du menu
			});
		}
	}
	////	Mode Normal
	else
	{
		////	Affiche via Mouseover ou click d'un launcher (icone/texte)
		$(".menuLaunch").on("mouseover click",function(event){
			event.stopPropagation();//Pas de probagation (selection du block ou autre)
			showContextMenu(this,event);
		});
		////	Affiche via Click Droit sur le block de l'objet
		$("[for^='objContextMenu_']").on("contextmenu",function(event){
			showContextMenu(this,event);
			return false;//pour pas afficher le menu du browser
		});
		////	Survol le block d'un objet : Masque les menus qui ne le concernent pas
		$("[for^='objContextMenu_']").on("mouseenter",function(){
			$(".contextMenu").not("#"+this.getAttribute("for")).fadeOut();
		});
		////	Quitte le menu : on le masque
		$(".contextMenu").on("mouseleave",function(){
			$(this).fadeOut();
		});
		////	Click dans les menus : pas de propagation
		$(".contextMenu,.objMiscMenu").click(function(event){
			event.stopPropagation();//Pas de probagation (selection du block ou autre)
		});
	}
}
/*
 * Affiche un menu contextuel
 */
function showContextMenu(launcher, event)
{
	////	Récup' l'Id du menu  &  Ferme les autres menus
	var menuId="#"+$(launcher).attr("for");
	$(".contextMenu").not(menuId).hide();
	////	Hauteur max du menu (fonction de la hauteur de page)
	$(menuId).css("max-height", Math.round($(window).height()-30)+"px");
	////	Positionne le menu en fonction du launcher
	var menuPosX=$(launcher).position().left;//Position du "launcher" : "menuLaunch" OU Block de l'objet ("contextmenu")
	var menuPosY=$(launcher).position().top;//idem
	////	Clic droit sur l'objet : Ajuste avec la position de la souris. Attention car la position "relative" du "objContainer" décale les "event.pageX/Y"
	if(event.type=="contextmenu")	{menuPosX=event.pageX-menuPosX-10;  menuPosY=event.pageY-menuPosY-10;}
	////	Menu au bord droit/bas de la page ?
	else
	{
		//Positions de base du menu
		var posMenuRight =menuPosX + $(menuId).outerWidth(true);
		var posMenuBottom=menuPosY + $(menuId).outerHeight(true);
		//Parent en position "relative" (majorité des cas) OU "absolute" : rajoute sa position
		var objSelector="#"+$(launcher).parent(".objContainer").attr("id");
		if($(objSelector).css("position")=="relative" || $(objSelector).css("position")=="absolute"){
			posMenuRight+=$(objSelector).offset().left;//utiliser "offset()" relatif au document et non "position()" relatif au parent..
			posMenuBottom+=$(objSelector).offset().top;
		}
		//Vérifie et ajuste si besoin la position
		var posPageRight=$(window).width();
		var posPageBottom=$(window).height()+$(window).scrollTop();
		if(posPageRight < posMenuRight)		{menuPosX=menuPosX-(posMenuRight-posPageRight)-10;}
		if(posPageBottom < posMenuBottom)	{menuPosY=menuPosY-(posMenuBottom-posPageBottom)-10;}
	}
	////	Positionne et affiche le menu
	$(menuId).css("left", Math.round(menuPosX)+"px").css("top", Math.round(menuPosY)+"px").fadeIn();
}

/*
 * Controle s'il s'agit d'un mail
 */
function isMail(mail)
{
	var mailRegex=/^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	return mailRegex.test(mail);
}

/*
 * Cherche une expression dans une chaine de caracteres
 */
function find(needle, haystack)
{
	//Convertir en texte puis en minuscule : recherche la position de needle dans haystack
	if(typeof haystack!="undefined")	{return (haystack.toString().toLowerCase().indexOf( needle.toString().toLowerCase() ) >= 0) ? true : false;}
}

/*
 * Affiche un message de notification (via le plugin Jquery "toastmessage")
 */
function notify(message, typeNotif)
{
	if(typeNotif=="success")		{var toastType="showSuccessToast";}	//Type "success" (vert)
	else if(typeNotif=="warning")	{var toastType="showWarningToast";}	//Type "warning" (jaune)
	else							{var toastType="showNoticeToast";}	//Type "info" (bleu) => par défaut
	if(inIframe())	{parent.$().toastmessage(toastType, message);}//lancé depuis une lightbox
	else			{$().toastmessage(toastType, message);}
}

/*
 * Redirection page
 */
function redir(adress, redirMainPage)
{
	if(redirMainPage===true)	{window.parent.location.href=adress;}
	else						{window.location.href=adress;}
}

/*
 * Lancé depuis une iframe ?
 */
function inIframe()
{
	return (window.parent && window.parent.location!=window.location);
}

/*
 * Ouvre une lightbox via une fonction (et non des "href" : plus souple + n'interfère pas avec "stopPropagation()" des "contextMenu()")
 * tests : edit object, open pdf/mp3, open mp4/webm, open userMap, open inline html
 */
function lightboxOpen(urlSrc)
{
	////	DEPUIS LIGHTBOX  /  PDF EN RESPONSIVE  /  MP3 (sans options!)  /  VIDEO
	if(inIframe())								{parent.lightboxOpen(urlSrc);}
	else if(/mp3$/i.test(urlSrc))				{$.fancybox.open('<div style="padding:50px;"><audio controls controlsList="nodownload"><source src="'+urlSrc+'" type="audio/mp3">HTML5 browser is required</audio></div>');}
	else if(/pdf$/i.test(urlSrc) && isMobile())	{window.open(urlSrc);}
	else if(/(mp4|webm)$/i.test(urlSrc))
	{
		var htmlSrc='<video controls controlsList="nodownload" autoplay style="max-height:90%;max-width:98%"><source src="'+urlSrc+'" type="video/'+extension(urlSrc)+'">HTML5 browser is required</video>';
		$.fancybox.open({type:"inline", src:htmlSrc, opts:{fullScreen:false,closeBtn:true,smallBtn:true,closeClickOutside:true}});
	}
	////	IFRAME
	else
	{
		$.fancybox.open({
			type:"iframe",
			src:urlSrc,
			opts:{
				fullScreen:false,
				closeClickOutside:true,//clique sur le "wrapper"
				beforeShow:function(){
					//Masque le contenu avant de redimensionner le lightbox
					$(".fancybox-inner").css("visibility","hidden");
				},
				afterShow:function(){
					//Si on edite un element, on demande confirmation avant de fermer la page et quitter le formulaire
					confirmCloseLightbox=false;
					if(find("edit",urlSrc))  {$(".fancybox-iframe").contents().find("form").on("click keyup",function(){ confirmCloseLightbox=true; });}
					//Redimentionne le lightbox en fonction du Width de la page
					this.width=$(".fancybox-iframe").contents().find("body").width();//cf. "lightboxWidth()"
					$.fancybox.getInstance().update();
					$(".fancybox-inner").css("visibility","visible");//Raffiche le contenu
				},
				beforeClose:function(){
					if(confirmCloseLightbox==true)  {return confirm(labelConfirmCloseLightbox);}
				}
			}
		});
	}
}

/*
 * Largeur d'une Lightbox (appelé depuis le lightbox)
 */
function lightboxWidth(pageWidth)
{
	$(function(){
		//Récup le width en pixel
		if(find("px",pageWidth))		{pageWidth=pageWidth.replace("px","");}
		else if(find("%",pageWidth))	{pageWidth=($(window.parent).width()/100) * pageWidth.replace("%","");}
		//Width du contenu > Width de la page (très petite resolution)
		if(pageWidth>$(window.parent).width())	{pageWidth=$(window.parent).width();}
		//Applique le width & Update le fancybox
		if(isEmptyValue(pageWidth)==false)	{$("body").css("width",pageWidth);}
	});
}

/*
 * Agrandit si besoin la hauteur d'une Lightbox : suite à un fadeIn() ou autre (avec "duration" de 100ms)
 */
function lightboxResize(forceResize)
{
	//Page déjà chargée && Lancé depuis une lightbox
	if(previouslyLoadedPage() && parent.$(".fancybox-container").is(":visible"))
	{
		//Hauteur du LightBox au début des "fadeIn" and co
		lightboxHeightOld=(inIframe())  ?  parent.$(".fancybox-iframe").contents().height()  :  $(".fancybox-inner").contents().height();
		//Réinit le "setTimeout" si besoin : pas de cumul
		if(typeof lightboxResizeTimeout!="undefined")  {clearTimeout(lightboxResizeTimeout);}
		//Lance l'update si le contenu est plus grand, avec "setTimeout()" le temps qu'agissent les "fadeIn" and co
		lightboxResizeTimeout=setTimeout(function(){
			var lightboxHeightNew=(inIframe())  ?  parent.$(".fancybox-iframe").contents().height()  :  $(".fancybox-inner").contents().height();
			if(lightboxHeightOld < lightboxHeightNew || forceResize===true)  {parent.$.fancybox.getInstance().update();}
		},300);
	}
}

/*
 * Afficher un "prompt" via le lightbox
 */
function lightboxPrompt(promptLabel, actionJS, inputType, defaultValue)
{
	if(isEmptyValue(inputType))		{inputType="text";}//"text" ou "password"
	if(isEmptyValue(defaultValue))	{defaultValue="";}//valeur par défaut dans l'input
	// Construit le formulaire
	var promptForm= "<div style='padding:20px'>\n\
						<div class='lightboxTitle'>"+promptLabel+"</div>\n\
						<input type='"+inputType+"' class='promptInputText' value=\""+defaultValue+"\" onkeydown=\"if(event.keyCode==13){"+actionJS+"}\"> &nbsp;\n\
						<button type='button' onclick=\"if($('.promptInputText').isEmpty()==false){"+actionJS+"}\">OK</button>\n\
					</div>";
	// Affiche le prompt et met le focus sur l'input
	$.fancybox.open({type:"inline", src:promptForm, opts:{fullScreen:false,closeBtn:true,smallBtn:false,closeClickOutside:true}});
	setTimeout(function(){
		$.fancybox.getInstance().update();
		$(".promptInputText").focus();//decalé, s'il y a au autre focus avant (cf. page de connexion)
	},300);
}

/*
 * Ferme le lightbox & reload si besoin la page principale (appelé depuis le lightbox)
 */
function lightboxClose(reloadParentPage, reloadSpecificUrl, urlMsgNotif)
{
	//Reload la page principale ? Url => passé en paramètre OU .parent (lightbox)
	var reloadUrl=null;
	if(reloadParentPage===true){
		reloadUrl=(isEmptyValue(reloadSpecificUrl)==false)  ?  reloadSpecificUrl  :  window.parent.location.href;	//Url passée en parametre OU Url de "parent"
		if(find("msgNotif",reloadUrl))	{reloadUrl=reloadUrl.substring(0,reloadUrl.indexOf('&msgNotif'));}			//Enlève si besoin le parametre "msgNotif" de l'url
		if(!isEmptyValue(urlMsgNotif))	{reloadUrl+=urlMsgNotif;}													//Au besoin, ajoute le nouveau parametre "msgNotif"
	}
	//Ferme le lightbox
	if(isEmptyValue(reloadUrl)==false)	{window.parent.location.replace(reloadUrl);}
	else								{parent.jQuery.fancybox.getInstance().close();}
}

/*
 * Navigation sur appareil tactile (fonctions php & js identiques & css=1200px max)
 */
function isMobile()
{
	return (/android|iphone|ipad|blackberry|windows phone|tablet|touch/i.test(navigator.userAgent) || $(window).outerWidth(true)<=1200);
}

/*
 * Version obsolete d'IE ?
 */
function isObsoleteIE()
{
	var vBrowser=navigator.appVersion;
	return (find("MSIE 5.",vBrowser) || find("MSIE 6.",vBrowser) || find("MSIE 7.",vBrowser) || find("MSIE 8.",vBrowser));
}

/*
 * Confirmer une suppression puis rediriger pour effectuer la suppresion
 */
function confirmDelete(redirUrl, labelConfirmDeleteDbl, ajaxControlUrl, ajaxConfirmLabel)
{
	//Effectue un controle Ajax?
	if(isEmptyValue(ajaxControlUrl)==false){
		var ajaxResult=$.ajax({url:ajaxControlUrl,async:false}).responseText;//Attend la réponse Ajax pour passer à la suite (async:false)
		if(ajaxResult!="true" && confirm(ajaxConfirmLabel)==false)	{return false;}//exple : "Attention! certains sous-dossiers ne vous sont pas accessibles en lecture.."
	}
	//Lance la suppression? ("labelConfirmDelete" : cf. "VueStructure.php")
	if(confirm(labelConfirmDelete)){
		if(isEmptyValue(labelConfirmDeleteDbl)==false && confirm(labelConfirmDeleteDbl)==false)  {return false;}
		redir(redirUrl);
	}
}

/*
 * Scroll vers un element OU en bas de page
 */
function toScroll(thisSelector)
{
	//Scroll si la page ne vient pas d'être chargé
	if(previouslyLoadedPage()){
		var heightReference=(typeof thisSelector!="undefined" && $(thisSelector).exist())  ?  $(thisSelector).position().top  :  $(document).height();
		$("html,body").animate({scrollTop:heightReference},100);
	}
}

/*
 * Extension d'un fichier (sans le point!)
 */
function extension(fileName)
{
	if(isEmptyValue(fileName)==false)	{return fileName.split('.').pop().toLowerCase();}
}

/*
 * Vérifie si une chaine est au format Json
 */
function isJsonString(string)
{
	try{
		JSON.parse(string);
	}catch(e){
		return false;
	}
	return true;
}

/*
 * Vérifie si une valeure est "empty" (équivalent à php)
 */
function isEmptyValue(value)
{
	return (value==null || typeof value=="undefined" || value=="" || value==0);
}

/*
 * La page ne vient pas d'être chargée à l'instant
 */
function previouslyLoadedPage()
{
	return ((Date.now()-pageLoadTimestamp)>1500);//1500ms minimum!
}


/***************************************************************************************************************************/
/*******************************************	SPECIFIC FUNCTIONS	********************************************************/
/***************************************************************************************************************************/


/*
 * Contrôle de connexion à l'agora
 */
function controlConnect()
{
	var inputLogin=$("[name=connectLogin]");
	var inputPassword=$("[name=connectPassword]");
	if(inputLogin.isEmpty() || inputLogin.val()==inputLogin.attr("placeholder") || inputPassword.isEmpty() || inputPassword.val()==inputPassword.attr("placeholder")){
		notify(labelSpecifyLoginPassword);
		return false;
	}
}

/*
 * PAGE INIT : Initialise l'affichage des pages principales
 * => menu flottant / largeur des blocks d'objet / clic sur les blocks d'objet
 */
function mainPageDisplay()
{
	////	Largeur des objets en affichage "block", en fonction de la largeur de la page
	if($(".objBlocks .objContainer").length>0)
	{
		//Marge & Largeur min/max des objets
		var objMargin=parseInt($(".objContainer").css("margin-right"))+1;
		var objMinWidth=parseInt($(".objContainer").css("min-width"));
		var objMaxWidth=parseInt($(".objContainer").css("max-width")) + objMargin;//ajoute la marge pour l'application du "width()"
		//Largeur disponible
		var containerWidth=$(".pageFullContent").width();//pas de "innerWidth()" car cela ajoute le "padding"
		if(isMobile()==false && $(document).height()==$(window).height())	{containerWidth=containerWidth-18;}//pas encore d'ascenseur : anticipe son apparition (sauf en responsive ou l'ascenseur est masqué)
		//Calcul la largeur des objets
		var objWidth=null;
		var lineNbObjects=Math.ceil(containerWidth / objMaxWidth);//Nb maxi d'objets par ligne
		if(containerWidth < (objMinWidth*2))				{objWidth=containerWidth;  $(".objContainer").css("max-width",containerWidth);}	//On peut afficher qu'un objet par ligne : il prendra la largeur du conteneur
		else if($(".objContainer").length<lineNbObjects)	{objWidth=objMaxWidth;}															//Nb d'objets insuffisant pour remplir la 1ère ligne : il prendra sa largeur maxi
		else												{objWidth=Math.floor(containerWidth/lineNbObjects);}							//Sinon on calcul : fonction du conteneur et du nb d'objets par ligne
		//Applique la largeur des blocks (enlève le margin: pas pris en compte par le "outerWidth")  &&  Rend visible si ce n'est pas le cas !!
		$(".objContainer").outerWidth(Math.round(objWidth-objMargin)+"px");
	}

	////	Click/DblClick sur les blocks conteneurs des objets (l'id du block doit commencer par "objBlock_")
	if($(".objContainer").exist())
	{
		//Pas sur mobile
		if(isMobile()==false)
		{
			$(".objContainer").click(function(){
				//Init
				var blockId="#"+this.id;
				timeDblClick=500;
				if(typeof timeLastClick=="undefined")	{timeLastClick=Date.now();  containerIdLastClick=this.id;}
				//Double click?
				diffNowAndLastClick=(Date.now()-timeLastClick);
				var isDblClick=(diffNowAndLastClick>10 && diffNowAndLastClick<timeDblClick && containerIdLastClick==this.id);
				//Action sur l'objet
				if(isDblClick==true && $(blockId).attr("data-urlEdit"))		{lightboxOpen($(blockId).attr("data-urlEdit"));}//dblClick + "data-urlEdit" => édition d'objet
				else if(isDblClick==false && typeof objSelect=="function")	{objSelect(this.id);}							//click + fonction "objSelect()" => lance la fonction (cf. "VueObjMenuSelection.php")
				//Update "lastClickTime" & "containerIdLastClick"
				timeLastClick=Date.now();
				containerIdLastClick=this.id;
			});
		}
	}

	////	Menu flottant du module (à gauche)
	if(isMobile()==false && $(".pageModMenuContainer").exist())
	{
		var pageMenuPos=$(".pageModMenuContainer").position();
		$(window).scroll(function(){
			var pageMenuHeight=pageMenuPos.top;//Init la position top du menu
			$(".pageModMenuContainer").children().each(function(){ pageMenuHeight+=$(this).outerHeight(true); });//hauteur de chaque element
			if(pageMenuHeight < $(window).height())  {$(".pageModMenuContainer").css("padding-top",$(window).scrollTop()+"px");}
		});
	}

	////	VISIBILITE DES OBJET ET DU FOOTER (FINALISE L'AFFICHAGE)
	$(".objBlocks").css("visibility","visible");//Ré-affiché après calcul du width des ".objContainer" (cf. "common.css" et voir ci-dessus)
	$("#pageFooterHtml").css("max-width", parseInt($(window).width()-$("#pageFooterIcon").width()-20));//Pour que "pageFooterHtml" ne se superpose pas à "pageFooterIcon"
	setTimeout(function(){  $(".pageFull,.pageCenter").css("margin-bottom",footerHeight());  },100);//Marge sous le contenu pour qu'il ne soit pas masqué par le Footer. Timeout car pour récupérer "footerHeight()" il faut que le "#livecounterMain" soit chargé via Ajax..
}

/*
 * Calcul la hauteur disponible pour le contenu principal de la page
 */
function availableContentHeight()
{
	//Height de la fenêtre (pas la page)  -  Position "top" du contenu  -  Height du footer
	return Math.round($(window).height() - $(".pageCenterContent,.pageFullContent,.pageEmptyContent").offset().top - footerHeight());
}

/*
 * Calcul la hauteur du footer
 */
function footerHeight()
{
	//Référence de hauteur de footer :  Icone du footer  /  Text html du footer  /  LivecounterMain (recupère la hauteur préétablie via CSS: le contenu du livecounter est chargé à postériori via Ajax!)
	var footerHeight=0;
	["#pageFooterIcon","#pageFooterHtml","#livecounterMain"].forEach(function(targetId){
		if($(targetId+":visible").exist() && $(targetId).outerHeight()>footerHeight)  {footerHeight=$(targetId).outerHeight();}
	});
	return footerHeight;
}

/*
 * PAGE INIT : Initialise les controles de champs -> Datepickers, FileSize controls, Integer, etc
 */
function inputControls()
{
	////	Init le Datepicker jquery-UI
	$(".dateInput, .dateBegin, .dateEnd").datepicker({
		dateFormat:"dd/mm/yy",
		firstDay:1,
		showOtherMonths: true,
		selectOtherMonths: true,
		onSelect:function(date){
			//Select .dateBegin -> bloque la date minimum de .dateEnd (mais pas inversement!)
			if($(this).hasClass("dateBegin"))	{$(".dateEnd").datepicker("option","minDate",date);}
			//Trigger sur le champ concerné pour continuer l'action
			$(this).trigger("change");
		}
	});
	////	Init le plugin Timepicker (jquery-UI)
	if(jQuery().timepicker){
		$(".timeBegin, .timeEnd").timepicker({timeFormat:"H:i"});
	}
	////	Readonly sur les datepickers et timepickers
	if(isMobile())	{$(".dateInput, .dateBegin, .dateEnd, .timeBegin, .timeEnd").attr("readonly","readonly").css("background-color","white");}

	////	Controle les dates de début/fin
	$(".dateBegin, .dateEnd, .timeBegin, .timeEnd").change(function(){
		//Masque le champ H:M?
		if($(this).hasClass("dateBegin") || $(this).hasClass("dateEnd")){
			var timeClass=$(this).hasClass("dateBegin") ? ".timeBegin" : ".timeEnd";
			if($(this).isEmpty()==false)	{$(timeClass).show();}
			else							{$(timeClass).hide();  $(timeClass).val(null);}
		}
		//Controle des date/time
		if($(".dateBegin").isEmpty()==false || $(".dateEnd").isEmpty()==false)
		{
			//Controle des "H:M"
			if($(this).hasClass("timeBegin") || $(this).hasClass("timeEnd"))
			{
				//Champ à controler
				var timeClass=$(this).hasClass("timeBegin") ? ".timeBegin" : ".timeEnd";
				//controle Regex des H:M
				var timeRegex=/^[0-2][0-9][:][0-5][0-9]$/;
				if($(timeClass).isEmpty()==false && timeRegex.test($(timeClass).val())==false){
					notify("H:m error");
					$(timeClass).val(null);
					return false;
				}
				//précise H:M de fin si vide et début précisé
				if($(".timeEnd").isEmpty())  {$(".timeEnd").val($(".timeBegin").val());}
			}
			//Début après Fin : message d'erreur
			if($(".dateBegin").isEmpty()==false && $(".dateEnd").isEmpty()==false)
			{
				var timestampBegin=$(".dateBegin").datepicker("getDate").getTime()/1000;//getTime() renvoie des millisecondes..
				var timestampEnd=$(".dateEnd").datepicker("getDate").getTime()/1000;//idem
				if($(".timeBegin").isEmpty()==false)	{var hourMinute=$(".timeBegin").val().split(":");	timestampBegin=timestampBegin + (hourMinute[0]*3600) + (hourMinute[1]*60);}
				if($(".timeEnd").isEmpty()==false)		{var hourMinute=$(".timeEnd").val().split(":");		timestampEnd=timestampEnd + (hourMinute[0]*3600) + (hourMinute[1]*60);}
				if(timestampBegin > timestampEnd)
				{
					//Date/heure de fin reculé : message d'erreur
					if($(this).hasClass("dateEnd") || $(this).hasClass("timeEnd"))	{notify(labelDateBeginEndControl);}
					//Modif la date/heure de fin ("setTimeout" pour éviter une re-modif du timePicker)
					setTimeout(function(){
						$(".dateEnd").val($(".dateBegin").val());
						$(".timeEnd").val($(".timeBegin").val());
					},500);
				}
			}
		}
	});

	////	Controle la taille des fichiers des inputs "file"
	$("input[type='file']").change(function(){
		if($(this).isEmpty()==false && this.files[0].size > valueUploadMaxFilesize){
			$(this).val("");
			notify(labelUploadMaxFilesize);
		}
	});

	////	Inputs de type "integer" -> doivent avoir une classe "integerValue"
	$(".integerValue").on("change keyup",function(){ 
		$(this).val($(this).val().replace(/\D/g,''));
	});

	////	Affecte une couleur à un input "select" (chaque option doit avoir un attribut "data-color")
	$("select option").each(function(){
		if(this.getAttribute("data-color"))  {$(this).css("background-color",this.getAttribute("data-color")).css("color","#fff");}
	});
	$("select").change(function(){
		var optionColor=$(this).find("option:selected").attr("data-color");
		if(isEmptyValue(optionColor)==false)	{$(this).css("background-color",optionColor).css("color","#fff");}
		else									{$(this).css("background-color","#fff").css("color","#000");}
	});
}

/*
 * Confirmation (ou pas) d'événement
 */
function confirmEventProposition(_idCal, _idEvt, divId)
{
	//Init
	var confirmed=false;
	var ajaxUrl="?ctrl=calendar&action=confirmEventProposition&targetObjId=calendar-"+_idCal+"&_idEvt="+_idEvt;
	//Demande de confirmation
	if(confirm(labelEvtConfirm))			{ajaxUrl+="&confirmed=1";  confirmed=true;}
	else if(confirm(labelEvtConfirmNot))	{ajaxUrl+="&confirmed=0";  confirmed=true;}
	//Lance la requête en Ajax
	if(confirmed==true){
		$.ajax(ajaxUrl).done(function(ajaxResult){
			//erreur ajax  ||  recharge la page et le calendrier  ||  supprime la proposition du menu
			if(find("true",ajaxResult)==false)	{notify("Confirm event proposition error");}
			else if(getUrlParam("ctrl",window.location.href)=="calendar")  {redir("?ctrl=calendar");}
			else{
				$("#"+divId).hide();
				if($(".confirmEventProposition").is(":visible")==false)  {$(".confirmEventLib").hide();}
			}
		});
	}
}

/*
 * Affectations des Spaces<->Users : userEdit OU spaceEdit (Click de Label/Checkbox)
 */
function initSpaceAffectations()
{
	//Click de Label
	$(".spaceAffectTable label").click(function(){
		//init
		var _idTarget=this.id.replace("target","");
		var box1="[name='spaceAffect[]'][value='"+_idTarget+"_1']";
		var box2="[name='spaceAffect[]'][value='"+_idTarget+"_2']";
		//Bascule les checkboxes
		var boxToCheck=null;
		if(!$(box1).prop("disabled") && !$(box1).prop("checked") && !$(box2).prop("checked"))	{boxToCheck=box1;}
		else if($(box1).prop("checked") && !$(box2).prop("checked"))							{boxToCheck=box2;}
		//Uncheck les boxes (sauf si disabled), Check celle sélectionnée
		$("[name='spaceAffect[]'][value^='"+_idTarget+"_']").not(":disabled[name='spaceAffect[]']").prop("checked",false);
		if(boxToCheck!=null)	$(boxToCheck).prop("checked",true);
		//Style des labels
		spaceAffectStyle();
	});
	//Click de Checkbox
	$(".spaceAffectTable :checkbox").change(function(){
		var _idTarget=$(this).val().slice(0, $(this).val().lastIndexOf("_"));//exple "1_2" => "1"
		$("[name='spaceAffect[]'][value^='"+_idTarget+"_']").not(this).not(":disabled[name='spaceAffect[]']").prop("checked",false);//"uncheck" les autres checkbox du "target"
		spaceAffectStyle();//Style des labels
	});
	//Init le style des labels
	spaceAffectStyle();
};

/*
 * Applique un style aux labels avec une checkbox cochée
 */
function spaceAffectStyle()
{
	//Réinit le style des labels et rows
	$(".spaceAffectTable label").removeClass("sAccessRead sAccessWrite");
	$(".spaceAffectRow").removeClass("sTableRowSelect");
	//Stylise les labels && la ligne sélectionnées
	$("[name='spaceAffect[]']:checked").each(function(){
		//récupère l'id de la cible && le droit d'accès associé à la box
		var targetRight=this.value.split('_').pop();
		var targetId=this.value.replace('_'+targetRight, '');
		//Stylise le label et la ligne
		if(targetRight=="2")		{$("#target"+targetId).addClass("sAccessWrite");}
		else if(targetRight=="1")	{$("#target"+targetId).addClass("sAccessRead");}
		$("#rowTarget"+targetId).addClass("sTableRowSelect");
	});
}

/*
 * Récupère dans une Url la valeur d'un parametre
 */
function getUrlParam(paramName, url)
{
	paramName=paramName.replace(/[\[\]]/g, "\\$&");
	var regex=new RegExp("[?&]"+paramName+"(=([^&#]*)|&|#|$)");
	var results=regex.exec(url);
	if(!results)			{return null;}
	else if(!results[2])	{return '';}
	else					{return decodeURIComponent(results[2].replace(/\+/g," "));}
}

/*
 * Valide le "like"/"dontlike" d'un objet
 */
function usersLikeValidate(targetObjId, likeValue)
{
	if(isEmptyValue(targetObjId)==false && isEmptyValue(likeValue)==false)
	{
		//Requête Ajax
		var ajaxUrl="?ctrl=object&action=UsersLikeValidate&targetObjId="+targetObjId+"&likeValue="+likeValue;
		$.ajax({url:ajaxUrl,dataType:"json"}).done(function(ajaxResult){
			//Init les id
			var idLike			="#likeMenu_"+targetObjId+"_like";
			var idDontlike		="#likeMenu_"+targetObjId+"_dontlike";
			var idCircleLike    =idLike+" .objMiscMenuCircle";
			var idCircleDontlike=idDontlike+" .objMiscMenuCircle";
			//Nb de likes/dontlikes dans les cercles
			$(idCircleLike+", "+idCircleDontlike).addClass("objMiscMenuCircleHide");//Réinit (Masque par défaut)
			if(parseInt(ajaxResult.nbLikes)>0)		{$(idCircleLike).removeClass("objMiscMenuCircleHide").html(ajaxResult.nbLikes);}
			if(parseInt(ajaxResult.nbDontlikes)>0)	{$(idCircleDontlike).removeClass("objMiscMenuCircleHide").html(ajaxResult.nbDontlikes);}
			//Liste des users dans les tooltip/title
			$(idLike).tooltipster("destroy").attr("title",ajaxResult.usersLikeList).tooltipster(tooltipsterOptions);
			$(idDontlike).tooltipster("destroy").attr("title",ajaxResult.usersDontlikeList).tooltipster(tooltipsterOptions);
			//Fait clignoter le like/dontlike  &&  affiche le tooltip (trigger mouseover)
			$(likeValue=="like"?idLike:idDontlike).effect("pulsate",{times:1},300).trigger("mouseover");
		});
	}
}